<template>
  <div class="flex flex-col">
    <div class="flex items-center justify-between p-5 border w-full h-15 mt-5">
      <div class="flex items-center">
        <input class="largerCheckbox" type="checkbox" @change="changeCheckbox"/>
        <span class="ml-3 text-xl h-8" :class="{'line-through' : props.todo.done}">
        {{props.todo.name}}
      </span>
      </div>
      <div class="flex items-center">
        <button class="border rounded-lg h-10 bg-teal-400 text-white w-28 mr-5" @click="showDetail()">Detail</button>
        <button class="border rounded-lg h-10 bg-red-600 text-white w-28" @click="removeTodo(props.todo.id)">Remove</button>
      </div>
    </div>
  </div>
  <div class="overflow-hidden h-0 todo-detail" :class="{ 'show': props.todo.showDetail }">
    <FormTodo
      :todo="props.todo"
      :type="'updateTodo'"
      @saveTodo="updateTodo()"
    >
    </FormTodo>
  </div>
</template>

<script setup lang="ts">
import { ref, computed } from 'vue'
import {useStore} from "vuex"
import Todo from "../type/todo"
import FormTodo from "./FormTodo.vue";

interface Props {
  todo: Todo
}

const props = defineProps<Props>()

const store = useStore();

function showDetail() {
  store.dispatch("showDetail", props.todo.id)
}

function removeTodo(id: number) {
  store.dispatch('removeTodo', id);
}

function updateTodo() {
  store.dispatch('updateTodo', props.todo)
}

function changeCheckbox(e: any) {
  if(e.target.checked) {
    store.dispatch("setListCheckBox",props.todo.id)
  }else {
    store.dispatch("removeCheckbox",props.todo.id)
  }
}

</script>
<style>
input.largerCheckbox {
  width: 20px;
  height: 20px;
}
.todo-detail {
  transition: height 0.6s, padding 0.6s ,border 0.6s;
}

.show {
  height: 500px !important;
  padding: 20px;
  border: 1px solid #e5e7eb;
}

@keyframes show {
  from {height: 0}
  to {height: 500px; padding: 20px; border: 1px solid #e5e7eb}
}
</style>
